#!/usr/bin/perl

# iiimpkana version 1.0
# Copyright (C) 2005 Hideki EIRAKU

# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

use Socket;

$addr = inet_aton ("127.0.0.1");
$name = pack_sockaddr_in (19010, $addr);
socket (S, PF_INET, SOCK_STREAM, 0);
connect (S, $name);
binmode (S);
binmode (STDIN);
binmode (STDOUT);
$| = 1;
$tbl = '>{}<:)#E$%^&*(Z`3e456tgh'."'".'bxdrpcqazwsui1,kfv2=-jn\/m789ol.;_0y[]';
$enable = 1;

if (fork ()) {				# parent process
	&sub_read_from_client ();
	shutdown (S, 1);
	close (S);
	exit (0);
} else {				# child process
	&sub_read_from_server ();
	shutdown (STDOUT, 1);
	close (S);
	exit (0);
}
# not reached

sub sub_read_from_client {
	while (1) {
		&sub_sub_read_one_packet (@data) || return 0;
		$cmd = $data[0] & 0x7f;
		if ($cmd == 1) {		# IM_CONNECT
			if ($data[$packethead] == 0x42) {
				$msbfirst = 1;
			} else {
				$msbfirst = 0;
			}
		} elsif ($cmd == 12) {		# IM_FORWARD_EVENT
			if (sub_sub_getint_data (4) == 2) {
				$keyeventlen = sub_sub_getint_data (8);
				for ($i = 0; $i + 15 < $keyeventlen; $i += 16) {
					# $keycod = sub_sub_getint_data (12+$i);
					$keychr = sub_sub_getint_data (16+$i);
					$keymod = sub_sub_getint_data (20+$i);
					# $timest = sub_sub_getint_data (24+$i);
					$idx = index ($tbl, pack ("C",$keychr));
					if (($keymod & ~1) == 0 && $idx >= 0 && $enable) {
						$keychr = $idx + 0xff61;
						sub_sub_setint_data (16+$i, $keychr);
					}
					if (($keymod&~1)==0 && $keychr==124) {
						$enable = 0;
					}
					if (($keymod&~1)==0 && $keychr==63) {
						$enable = 1;
					}
				}
				$buf = pack ("C*", @data);
			}
		}
		&sub_syswrite (S, $buf, $packethead + $totallen) || return 0;
	}
	return 1;

}

sub sub_sub_read_one_packet {
	&sub_sysread (STDIN, \$buf, 1, 0) || return 0;
	@data = unpack ("C*", $buf);
	if ($data[0] & 0x80) {
		&sub_sysread (STDIN, \$buf, 7, 1) || return 0;
		@data = unpack ("C*", $buf);
		$totallen = (($data[1] << 48) +
			     ($data[2] << 40) +
			     ($data[3] << 32) +
			     ($data[4] << 24) +
			     ($data[5] << 16) +
			     ($data[6] << 8) +
			     ($data[7] << 0)) * 4;
		$packethead = 8;
	} else {
		&sub_sysread (STDIN, \$buf, 3, 1) || return 0;
		@data = unpack ("C*", $buf);
		$totallen = (($data[1] << 16) +
			     ($data[2] << 8) +
			     ($data[3] << 0)) * 4;
		$packethead = 4;
	}
	&sub_sysread (STDIN, \$buf, $totallen, $packethead) || return 0;
	@data = unpack ("C*", $buf);
	return 1;
}

sub sub_sub_getint {
	my (@a);

	(@a) = @_;
	if (!$msbfirst) {
		@a = reverse (@a);
	}
	return unpack ("N", pack ("C*", @a));
}

sub sub_sub_getint_data {
	my ($a);

	($a) = @_;
	return sub_sub_getint (@data[$packethead + $a .. $packethead + $a + 3]);
}

sub sub_sub_setint_data {
	my ($a, $b, @c);

	($a, $b) = @_;
	@c = unpack ("C*", pack ("N", $b));
	if (!$msbfirst) {
		@c = reverse (@c);
	}
	@data[$packethead + $a .. $packethead + $a + 3] = @c;
}

sub sub_read_from_server {
	my ($buf, $rlen);

	while ($rlen = sysread (S, $buf, 1024)) {
		&sub_syswrite (STDOUT, $buf, $rlen) || return 0;
	}
	return 1;
}

sub sub_sysread {
	my ($in, $buf, $len, $off, $rlen, $rlen1);

	($in, $buf, $len, $off) = @_;
	$rlen = 0;
	while ($rlen < $len) {
		$rlen1 = sysread ($in, $$buf, $len - $rlen, $off + $rlen);
		if (!$rlen1) {
			return 0;
		}
		$rlen += $rlen1;
	}
	return 1;
}

sub sub_syswrite {
	my ($out, $buf, $rlen, $wlen, $wlen1);

	($out, $buf, $rlen) = @_;
	$wlen = 0;
	while ($wlen < $rlen) {
		$wlen1 = syswrite ($out, $buf, $rlen - $wlen, $wlen);
		if (!$wlen1) {
			return 0;
		}
		$wlen += $wlen1;
	}
	return 1;
}
